function [imdb, fn] = convert2imdb(img_mat, labels, num_img)
% --------------------------------------------------------------------

   masks = []; 


numImages = size(img_mat, 4);
imdb.images.data = img_mat ;
imdb.images.set = ones(1, numImages);
if nargin > 2
    imdb.images.set(num_img+1:numImages) = 3;
else
    imdb.images.set(numImages*0.6+1:numImages) = 3;
end
imdb.meta.sets = {'train', 'val', 'test'} ;
imdb.images.label = labels;

if(~isempty(masks))
    imdb.images.masks = masks;
    fn = @(imdb,batch)getBatch_mask(imdb,batch);
else
    fn = @(imdb,batch)getBatch(imdb,batch);
end
imdb.classes.name = unique(labels);
end

function [im, labels] = getBatch(imdb, batch)
% --------------------------------------------------------------------
im = imdb.images.data(:,:,:,batch) ;
labels = imdb.images.label(batch) ;
end

function [im, labels, mask] = getBatch_mask(imdb, batch)
% --------------------------------------------------------------------
im = imdb.images.data(:,:,:,batch) ;
labels = ones(1, numel(batch), 'single');
labels(1:6) = 1;
labels(7:end) = 2;
mask = imdb.images.masks(:,:,:,batch);
end