function [net1, net2, net3, net4] = convNet_discriminative(net1, net2, net3, config)
opts.scale = 1 ;
opts.initBias = 0.1 ;
opts.weightDecay = 1 ;
opts.weightInitMethod = 'gaussian' ;
opts.model = 'alexnet' ;
opts.batchNormalization = true;
opts.addrelu = true;
opts.leak = 0.2;

num_in = -1;
%% set up network 1
for i = numel(net1.layers):-1:1
    l = net1.layers{i};
   if strcmp(l.type, 'conv') || strcmp(l.type, 'convt')
       num_in = size(l.weights{1}, 4);
       break;
   end
end

num_out = num_in;
net1.layer_sets = numel(net1.layers)+1;

% layer 1
layer_name = 'dis_1';
num_out = 128;
filter_sz = 3;
stride = 1;
pad = 1 * ones(1, 4);
net1 = add_cnn_block(net1, opts, layer_name, filter_sz, filter_sz, num_in, num_out, stride, pad);

% layer 2
layer_name = 'dis_2';
num_in = num_out;
num_out = 64;
filter_sz = 1;
stride = 1;
pad = 0 * ones(1, 4);
net1 = add_cnn_block(net1, opts, layer_name, filter_sz, filter_sz, num_in, num_out, stride, pad);

% layer 3
layer_name = 'dis_3';
num_in = num_out;
num_out = 64;
filter_sz = 1;
stride = 1;
pad = 0 * ones(1, 4);
net1 = add_cnn_block(net1, opts, layer_name, filter_sz, filter_sz, num_in, num_out, stride, pad);

img = randn([config.res(2), config.res(2), 3], 'single');
net1 = vl_simplenn_move(net1, 'gpu') ;
res = vl_simplenn(net1, gpuArray(img));
net1 = vl_simplenn_move(net1, 'cpu');
dydz_sz1 = size(res(end).x);

% net1.layers{end+1} = struct('type', 'pool', ...
%                            'method', 'avg', ...
%                            'pool', [dydz_sz1(1) dydz_sz1(1)], ...
%                            'stride', 1, ...
%                            'pad',0) ;
%                        
% net1 = vl_simplenn_move(net1, 'gpu') ;
% res = vl_simplenn(net1, gpuArray(img));
% net1 = vl_simplenn_move(net1, 'cpu');
% dydz_sz1 = size(res(end).x);

net1.layer_sets = numel(net1.layers):-1:net1.layer_sets; 
% net1.dydz_sz = dydz_sz1;
%% set up network 2
for i = numel(net2.layers):-1:1
    l = net2.layers{i};
   if strcmp(l.type, 'conv') || strcmp(l.type, 'convt')
       num_in = size(l.weights{1}, 4);
       break;
   end
end

num_out = num_in;
net2.layer_sets = numel(net2.layers)+1;

% layer 1
layer_name = 'dis_1';
num_out = 128;
filter_sz = 3;
stride = 1;
pad = 1 * ones(1, 4);
net2 = add_cnn_block(net2, opts, layer_name, filter_sz, filter_sz, num_in, num_out, stride, pad);

% layer 2
layer_name = 'dis_2';
num_in = num_out;
num_out = 64;
filter_sz = 1;
stride = 1;
pad = 0 * ones(1, 4);
net2 = add_cnn_block(net2, opts, layer_name, filter_sz, filter_sz, num_in, num_out, stride, pad);

% layer 3
layer_name = 'dis_3';
num_in = num_out;
num_out = 64;
filter_sz = 1;
stride = 1;
pad = 0 * ones(1, 4);
net2 = add_cnn_block(net2, opts, layer_name, filter_sz, filter_sz, num_in, num_out, stride, pad);

img = randn([config.res(3), config.res(3), 3], 'single');
net2 = vl_simplenn_move(net2, 'gpu') ;
res = vl_simplenn(net2, gpuArray(img));
net2 = vl_simplenn_move(net2, 'cpu');
dydz_sz2 = size(res(end).x);

% net2.layers{end+1} = struct('type', 'pool', ...
%                            'method', 'avg', ...
%                            'pool', [dydz_sz2(1) dydz_sz2(1)], ...
%                            'stride', 1, ...
%                            'pad',0) ;
%                        
% net2 = vl_simplenn_move(net2, 'gpu') ;
% res = vl_simplenn(net2, gpuArray(img));
% net2 = vl_simplenn_move(net2, 'cpu');
% dydz_sz2 = size(res(end).x);
net2.layer_sets = numel(net2.layers):-1:net2.layer_sets; 
% net2.dydz_sz = dydz_sz2;
%% set up network 3
for i = numel(net3.layers):-1:1
    l = net3.layers{i};
   if strcmp(l.type, 'conv') || strcmp(l.type, 'convt')
       num_in = size(l.weights{1}, 4);
       break;
   end
end

num_out = num_in;
net3.layer_sets = numel(net3.layers)+1;

% layer 1
layer_name = 'dis_1';
num_out = 128;
filter_sz = 3;
stride = 1;
pad = 1 * ones(1, 4);
net3 = add_cnn_block(net3, opts, layer_name, filter_sz, filter_sz, num_in, num_out, stride, pad);

% layer 2
layer_name = 'dis_2';
num_in = num_out;
num_out = 64;
filter_sz = 1;
stride = 1;
pad = 0 * ones(1, 4);
net3 = add_cnn_block(net3, opts, layer_name, filter_sz, filter_sz, num_in, num_out, stride, pad);

% layer 3
layer_name = 'dis_3';
num_in = num_out;
num_out = 64;
filter_sz = 1;
stride = 1;
pad = 0 * ones(1, 4);
net3 = add_cnn_block(net3, opts, layer_name, filter_sz, filter_sz, num_in, num_out, stride, pad);

img = randn([config.res(4), config.res(4), 3], 'single');
net3 = vl_simplenn_move(net3, 'gpu') ;
res = vl_simplenn(net3, gpuArray(img));
net3 = vl_simplenn_move(net3, 'cpu');
dydz_sz3 = size(res(end).x);

% net3.layers{end+1} = struct('type', 'pool', ...
%                            'method', 'avg', ...
%                            'pool', [dydz_sz3(1) dydz_sz3(1)], ...
%                            'stride', 1, ...
%                            'pad',0) ;
%                        
% net3 = vl_simplenn_move(net3, 'gpu') ;
% res = vl_simplenn(net3, gpuArray(img));
% net3 = vl_simplenn_move(net3, 'cpu');
% dydz_sz3 = size(res(end).x);

net3.layer_sets = numel(net3.layers):-1:net3.layer_sets; 
% net3.dydz_sz = dydz_sz3;
%% layer top
opts.batchNormalization = false;
opts.addrelu = false;

net4.layers = [];

layer_name = 'dis_4';
num_in = num_out;
num_out = config.num_class;
filter_sz = prod(dydz_sz1(1:2)) + prod(dydz_sz2(1:2)) + prod(dydz_sz3(1:2));
stride = 1;
pad = 2 * zeros(1, 4);
net4 = add_cnn_block(net4, opts, layer_name, 1, filter_sz, num_in, num_out, stride, pad);

net4.layers{end+1} = struct('type', 'softmaxloss', 'name', 'loss');

net4.layer_sets = numel(net4.layers):-1:1;


