function config = discriminative_config(opts)

% we only support gpu
config.gpus = 1;

% category name
config.categoryName = opts.categoryName;
config.res = opts.res;
% image path: where the dataset locates
data_path = '../../image/';
config.inPath = [data_path, config.categoryName, '/'];
config.datatype = 'svhn';

% 3rd party path: where the matconvnn locates
config.matconvv_path = '../matconvnet-1.0-beta16/';

% parameter for synthesis
% nTileRow \times nTileCol defines the number of paralle chains
% right now, we currently support square chains, e.g. 2*2, 6*6, 10*10 ...

config.force_learn = true;
config.batch_size = 100;

config.numEpochs = 50; % 200

config.learningRate = logspace(-2, -4, 60) * 0.2;%0.2

config.sx = 64;
config.sy = 64;

run(fullfile(config.matconvv_path, 'matlab', 'vl_setupnn.m'));
addpath(genpath('./core/') )

% result file: no need to change
config.working_folder = opts.working_folder;


% create directory
if ~exist('./working/', 'dir')
    mkdir('./working/')
end

if ~exist(opts.working_folder, 'dir')
    mkdir(opts.working_folder);
end
