function [net1, net2, net3, config] = learn_discriminative(net1, net2, net3, opts, num_img)

rng(1);

learningTime = tic;
category = opts.categoryName;

fprintf('Learning category: %s\n', category);

opts.working_folder = ['./working/', opts.categoryName, '_',num2str(num_img),'imgs_131iter/'];
config = discriminative_config(opts);

if nargin >2
    config.num_img = num_img;
end
%% create imdb
[imdb, getBatch] = create_imdb(config);
config.num_class = numel(imdb.classes.name);

%% Setup Network 1
[net1, net2, net3, net4] = convNet_discriminative(net1, net2, net3, config);

%% Step 3: training
[net1, net2, net3, config] = train_model_discriminative(config, net1, net2, net3, net4, imdb, getBatch);

learningTime = toc(learningTime);
hrs = floor(learningTime / 3600);
learningTime = mod(learningTime, 3600);
mins = floor(learningTime / 60);
secds = mod(learningTime, 60);
fprintf('total learning time is %d hours / %d minutes / %.2f seconds.\n', hrs, mins, secds);